using System;
using System.Collections;
using System.Runtime.InteropServices;
using System.Runtime.InteropServices.ComTypes;
using System.Threading;

namespace Decal.Interop.Controls;

internal sealed class IChoiceEvents_EventProvider : IChoiceEvents_Event, IDisposable
{
	private IConnectionPointContainer m_ConnectionPointContainer;

	private ArrayList m_aEventSinkHelpers;

	private IConnectionPoint m_ConnectionPoint;

	private void Init()
	{
		IConnectionPoint ppCP = null;
		Guid riid = new Guid(new byte[16]
		{
			163, 54, 62, 118, 156, 56, 235, 66, 165, 243,
			194, 8, 208, 40, 249, 171
		});
		m_ConnectionPointContainer.FindConnectionPoint(ref riid, out ppCP);
		m_ConnectionPoint = ppCP;
		m_aEventSinkHelpers = new ArrayList();
	}

	event IChoiceEvents_DestroyEventHandler IChoiceEvents_Event.Destroy
	{
		add
		{

			bool lockTaken = default(bool);
			try
			{
				Monitor.Enter(this, ref lockTaken);
				if (m_ConnectionPoint == null)
				{
					Init();
				}
				IChoiceEvents_SinkHelper choiceEvents_SinkHelper = new IChoiceEvents_SinkHelper();
				int pdwCookie = 0;
				m_ConnectionPoint.Advise(choiceEvents_SinkHelper, out pdwCookie);
				choiceEvents_SinkHelper.m_dwCookie = pdwCookie;
				choiceEvents_SinkHelper.m_DestroyDelegate = value;
				m_aEventSinkHelpers.Add(choiceEvents_SinkHelper);
			}
			finally
			{
				if (lockTaken)
				{
					Monitor.Exit(this);
				}
			}
	
		}
		remove
		{

			bool lockTaken = default(bool);
			try
			{
				Monitor.Enter(this, ref lockTaken);
				if (m_aEventSinkHelpers == null)
				{
					return;
				}
				int count = m_aEventSinkHelpers.Count;
				int num = 0;
				if (0 >= count)
				{
					return;
				}
				do
				{
					IChoiceEvents_SinkHelper choiceEvents_SinkHelper = (IChoiceEvents_SinkHelper)m_aEventSinkHelpers[num];
					if (choiceEvents_SinkHelper.m_DestroyDelegate != null && ((choiceEvents_SinkHelper.m_DestroyDelegate.Equals(value) ? 1u : 0u) & 0xFFu) != 0)
					{
						m_aEventSinkHelpers.RemoveAt(num);
						m_ConnectionPoint.Unadvise(choiceEvents_SinkHelper.m_dwCookie);
						if (count <= 1)
						{
							Marshal.ReleaseComObject(m_ConnectionPoint);
							m_ConnectionPoint = null;
							m_aEventSinkHelpers = null;
						}
						break;
					}
					num++;
				}
				while (num < count);
			}
			finally
			{
				if (lockTaken)
				{
					Monitor.Exit(this);
				}
			}
	
		}
	}

	event IChoiceEvents_ChangeEventHandler IChoiceEvents_Event.Change
	{
		add
		{

			bool lockTaken = default(bool);
			try
			{
				Monitor.Enter(this, ref lockTaken);
				if (m_ConnectionPoint == null)
				{
					Init();
				}
				IChoiceEvents_SinkHelper choiceEvents_SinkHelper = new IChoiceEvents_SinkHelper();
				int pdwCookie = 0;
				m_ConnectionPoint.Advise(choiceEvents_SinkHelper, out pdwCookie);
				choiceEvents_SinkHelper.m_dwCookie = pdwCookie;
				choiceEvents_SinkHelper.m_ChangeDelegate = value;
				m_aEventSinkHelpers.Add(choiceEvents_SinkHelper);
			}
			finally
			{
				if (lockTaken)
				{
					Monitor.Exit(this);
				}
			}
	
		}
		remove
		{

			bool lockTaken = default(bool);
			try
			{
				Monitor.Enter(this, ref lockTaken);
				if (m_aEventSinkHelpers == null)
				{
					return;
				}
				int count = m_aEventSinkHelpers.Count;
				int num = 0;
				if (0 >= count)
				{
					return;
				}
				do
				{
					IChoiceEvents_SinkHelper choiceEvents_SinkHelper = (IChoiceEvents_SinkHelper)m_aEventSinkHelpers[num];
					if (choiceEvents_SinkHelper.m_ChangeDelegate != null && ((choiceEvents_SinkHelper.m_ChangeDelegate.Equals(value) ? 1u : 0u) & 0xFFu) != 0)
					{
						m_aEventSinkHelpers.RemoveAt(num);
						m_ConnectionPoint.Unadvise(choiceEvents_SinkHelper.m_dwCookie);
						if (count <= 1)
						{
							Marshal.ReleaseComObject(m_ConnectionPoint);
							m_ConnectionPoint = null;
							m_aEventSinkHelpers = null;
						}
						break;
					}
					num++;
				}
				while (num < count);
			}
			finally
			{
				if (lockTaken)
				{
					Monitor.Exit(this);
				}
			}
	
		}
	}

	event IChoiceEvents_DropDownEventHandler IChoiceEvents_Event.DropDown
	{
		add
		{

			bool lockTaken = default(bool);
			try
			{
				Monitor.Enter(this, ref lockTaken);
				if (m_ConnectionPoint == null)
				{
					Init();
				}
				IChoiceEvents_SinkHelper choiceEvents_SinkHelper = new IChoiceEvents_SinkHelper();
				int pdwCookie = 0;
				m_ConnectionPoint.Advise(choiceEvents_SinkHelper, out pdwCookie);
				choiceEvents_SinkHelper.m_dwCookie = pdwCookie;
				choiceEvents_SinkHelper.m_DropDownDelegate = value;
				m_aEventSinkHelpers.Add(choiceEvents_SinkHelper);
			}
			finally
			{
				if (lockTaken)
				{
					Monitor.Exit(this);
				}
			}
	
		}
		remove
		{

			bool lockTaken = default(bool);
			try
			{
				Monitor.Enter(this, ref lockTaken);
				if (m_aEventSinkHelpers == null)
				{
					return;
				}
				int count = m_aEventSinkHelpers.Count;
				int num = 0;
				if (0 >= count)
				{
					return;
				}
				do
				{
					IChoiceEvents_SinkHelper choiceEvents_SinkHelper = (IChoiceEvents_SinkHelper)m_aEventSinkHelpers[num];
					if (choiceEvents_SinkHelper.m_DropDownDelegate != null && ((choiceEvents_SinkHelper.m_DropDownDelegate.Equals(value) ? 1u : 0u) & 0xFFu) != 0)
					{
						m_aEventSinkHelpers.RemoveAt(num);
						m_ConnectionPoint.Unadvise(choiceEvents_SinkHelper.m_dwCookie);
						if (count <= 1)
						{
							Marshal.ReleaseComObject(m_ConnectionPoint);
							m_ConnectionPoint = null;
							m_aEventSinkHelpers = null;
						}
						break;
					}
					num++;
				}
				while (num < count);
			}
			finally
			{
				if (lockTaken)
				{
					Monitor.Exit(this);
				}
			}
	
		}
	}

	public IChoiceEvents_EventProvider(object P_0)
	{
		//Error decoding local variables: Signature type sequence must have at least one element.
		m_ConnectionPointContainer = (IConnectionPointContainer)P_0;
	}

	public void Finalize()
	{
		bool lockTaken = default(bool);
		try
		{
			Monitor.Enter(this, ref lockTaken);
			if (m_ConnectionPoint == null)
			{
				return;
			}
			int count = m_aEventSinkHelpers.Count;
			int num = 0;
			if (0 < count)
			{
				do
				{
					IChoiceEvents_SinkHelper choiceEvents_SinkHelper = (IChoiceEvents_SinkHelper)m_aEventSinkHelpers[num];
					m_ConnectionPoint.Unadvise(choiceEvents_SinkHelper.m_dwCookie);
					num++;
				}
				while (num < count);
			}
			Marshal.ReleaseComObject(m_ConnectionPoint);
		}
		catch (Exception)
		{
		}
		finally
		{
			if (lockTaken)
			{
				Monitor.Exit(this);
			}
		}
	}

	public void Dispose()
	{
		//Error decoding local variables: Signature type sequence must have at least one element.
		Finalize();
		GC.SuppressFinalize(this);
	}
}
